close all
clear all
clc

F_1H = 200e6;
F_23Na = 53e6;
Zcoil_1H = 11.6 + 1i*136.1;
Zcoil_23Na = 0.5 + 1i*29.6;

%% Calculate Decoupling for 1H
Decoupling_1H_open = Decoupling_Calculation(Zcoil_1H,z2gamma(1e9))
Decoupling_1H_short = Decoupling_Calculation(Zcoil_1H,z2gamma(0))
Decoupling_1H_3pF = Decoupling_Calculation(Zcoil_1H,z2gamma(1/(2*pi*F_1H*3e-12)))
Decoupling_1H_6_8pF = Decoupling_Calculation(Zcoil_1H,z2gamma(1/(2*pi*F_1H*6.8e-12)))
Decoupling_1H_20pF = Decoupling_Calculation(Zcoil_1H,z2gamma(1/(2*pi*F_1H*20e-12)))
Decoupling_1H_47pF = Decoupling_Calculation(Zcoil_1H,z2gamma(1/(2*pi*F_1H*47e-12)))
Decoupling_1H_82pF = Decoupling_Calculation(Zcoil_1H,z2gamma(1/(2*pi*F_1H*82e-12)))
Decoupling_1H_115pF = Decoupling_Calculation(Zcoil_1H,z2gamma(1/(2*pi*F_1H*115e-12)))

%% Calculate Decoupling for 23Na
% Decoupling_23Na = Decoupling_Calculation(Zcoil_23Na,1.04-1i*31.07);

Decoupling_23Na_open = Decoupling_Calculation(Zcoil_23Na,z2gamma(1e9))
Decoupling_23Na_short = Decoupling_Calculation(Zcoil_23Na,z2gamma(0))
Decoupling_23Na_3pF = Decoupling_Calculation(Zcoil_23Na,z2gamma(1/(2*pi*F_23Na*3e-12)))
Decoupling_23Na_6_8pF = Decoupling_Calculation(Zcoil_23Na,z2gamma(1/(2*pi*F_23Na*6.8e-12)))
Decoupling_23Na_20pF = Decoupling_Calculation(Zcoil_23Na,z2gamma(1/(2*pi*F_23Na*20e-12)))
Decoupling_23Na_47pF = Decoupling_Calculation(Zcoil_23Na,z2gamma(1/(2*pi*F_23Na*47e-12)))
Decoupling_23Na_82pF = Decoupling_Calculation(Zcoil_23Na,z2gamma(1/(2*pi*F_23Na*82e-12)))
Decoupling_23Na_115pF = Decoupling_Calculation(Zcoil_23Na,z2gamma(1/(2*pi*F_23Na*115e-12)))