function [Component_Matrix] = Gamma2MN(Z_Source, Gammas,Frequency)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   1st   |  2nd  |   3rd    |   4th    |
%   H     |  L-0  | Series-0 |    0     |
%   F     |  C-1  | Shunt-1  |    0     |
% Z Ratio | Tsfr-2|  Tsfr-2  |    0     |
%   Z0    |  TL-3 |   TL-3   | Length(m)|
%   Ohm   |  R-4  |          |          |
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Gammas_conj = conj(Gammas);
Z_Conj = gamma2z(Gammas_conj);
[row,column] = size(Gammas_conj);

% parfor i = 1: column
for i = 1: column    
    
    mnobj = matchingnetwork('SourceImpedance',Z_Source,'LoadImpedance',...
        Z_Conj(i),'CenterFrequency',Frequency,'Components',2);
    [circuit_list, performance] = circuitDescriptions(mnobj);
    MN = table2array(circuit_list);
%     MN(:,1) = [];
    

    % here convert 1st element to format to mine
    if MN(1,1) == "Series C"
        Temp1(1,:,i) = [
                                    str2num(MN(1,2)) 1 0 0;
                                    ];
    elseif MN(1,1) == "Shunt C"
        Temp1(1,:,i) = [
                                    str2num(MN(1,2)) 1 1 0;
                                    ];
    elseif MN(1,1) == "Series L"
        Temp1(1,:,i) = [
                                    str2num(MN(1,2)) 0 0 0;
                                    ];
    elseif MN(1,1) == "Shunt L"
        Temp1(1,:,i) = [
                                    str2num(MN(1,2)) 0 1 0;
                                    ];    
    else 
        error('Gamma2MN, something wrong, 1st element')
    end
    
    % here convert 2st element to format to mine
    if MN(1,3) == "Series C"
        Temp2(1,:,i) = [
                                    str2num(MN(1,4)) 1 0 0;
                                    ];
    elseif MN(1,3) == "Shunt C"
        Temp2(1,:,i) = [
                                    str2num(MN(1,4)) 1 1 0;
                                    ];
    elseif MN(1,3) == "Series L"
        Temp2(1,:,i) = [
                                    str2num(MN(1,4)) 0 0 0;
                                    ];
    elseif MN(1,3) == "Shunt L"
        Temp2(1,:,i) = [
                                    str2num(MN(1,4)) 0 1 0;
                                    ];    
    else 
        error('Gamma2MN, something wrong, 2nd element')
    end

    
end
    Component_Matrix(1,:,:) = Temp1;
    Component_Matrix(2,:,:) = Temp2;
end