function [] = SmithPlot_ProgressReport(Z_right,Data,Cres,Dmax,Dmin,ThreFlag,markersize,NF_Area,Nuclei,VI2)

Gammas = conj(z2gamma( Z_right )');
% 2H at 3.2680 MHz  43
% 31P at 8.6175 MHz, 115
% 1H at 21.2850 MHz, index at 284

% Freq_27MHZ_Index =  34; %17O 27.1284MHz
% Freq_30MHZ_Index =  43; %2H 30.7192 MHZ
% Freq_50MHZ_Index =  78;  %13C, 50.3294MHZ
% Freq_53MHZ_Index =  115;  %23Na
% Freq_53MHZ_Index =  201;  %23Na
% Freq_81MHZ_Index =  136;  %31P, 81.0045MHZ
% Freq_188MHZ_Index =  341;  %19F, 188.24MHZ
% Freq_200MHZ_Index = 284; %1H


% Freq_50MHZ_Index =  204; % 13C
% Freq_53MHZ_Index =  225;  %23Na

% Freq_27MHZ_Index =  34; %17O 27.1284MHz
Freq_30MHZ_Index =  48; %2H 30.7192 MHZ
Freq_50MHZ_Index =  114;  %13C, 50.3294MHZ
Freq_53MHZ_Index =  181;  %23Na
% Freq_53MHZ_Index =  201;  %23Na
Freq_81MHZ_Index =  248;  %31P, 81.0045MHZ
Freq_188MHZ_Index =  314;  %19F, 188.24MHZ
Freq_200MHZ_Index = 381; %1H


% Set up color scale
% Cres = 256;
% map = flipud( parula(Cres) );
map = ( parula(Cres) );
% Dmax = 5;
% Dmin = 0;
% Thresholding data to maximum value
if ThreFlag == "Higher"
    Above = Data >Dmax;
    Data = (1-Above).* Data + Above.*(Dmax);
    Color_Index = ceil( rescale(Data, 1 , 256) );
elseif ThreFlag == "Lower"
    Below = Data <Dmin;
    Data = (1-Below).* Data + Below.*(Dmin); 
    Color_Index = ceil( rescale(Data, 1 , 256) );
elseif ThreFlag == "None"
    Data = Data;
    Color_Index = ceil( rescale(Data, 1 , 256) );
elseif ThreFlag == "2color"
    Above = Data >Dmax;
    Below = Data <= Dmax;
    Color_Index = Above*Cres + Below*1;
end


[lines, hsm] = smithchart();
hold on
for i = 1:size(Gammas,2)
    [lines, hsm] = smithchart(Gammas(i));
    set(lines,'Marker', 'o','MarkerSize',markersize)
    set(lines,'Color', map(Color_Index(i),:),'MarkerSize',markersize);
%     set(lines,'Color', ThreshNF(NFs(i)));
    if i <= 400
        x1 = real(Gammas(i));
        x2 = real(Gammas(i+1));
        y1 = imag(Gammas(i));
        y2 = imag(Gammas(i+1));
        plot( [x1 x2],[y1 y2] , 'Color','b')
    end
end
hold off

if NF_Area == "NF_Area_On"
    % Area for good NF
hold on

r = 0.3;
xc = 0.57;
yc = 0.38;
theta = linspace(0,2*pi);
x = r*cos(theta) + xc;
y = r*sin(theta) + yc;
plot(x,y, 'b')

r = 0.32;
xc = 0.66;
yc = 0.09;
theta = linspace(0,2*pi);
x = r*cos(theta) + xc;
y = r*sin(theta) + yc;
plot(x,y, 'r')
% 
% r = 0.6;
% xc = 0;
% yc = 0;
% theta = linspace(0,2*pi);
% x = r*cos(theta) + xc;
% y = r*sin(theta) + yc;
% plot(x,y, 'r')
% r = 0.9;
% x = r*cos(theta) + xc;
% y = r*sin(theta) + yc;
% plot(x,y, 'r')
% line( [0,0.5504] , [0,0.7987]  )
% line( [0,0.9011] , [0,0.3799]  )
% line( [0,0.8879] , [0,-0.4594]  )
hold off
end

if Nuclei == "Nuclei_On"



hold on
% 
% plot(real( z2gamma(Z_right(Freq_27MHZ_Index)) ),imag(z2gamma(Z_right(Freq_27MHZ_Index))),'ro','LineWidth',3,'Color', 'k');
% text(real( z2gamma(Z_right(Freq_27MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_27MHZ_Index)))+0.1,["30MHZ ", num2str(Z_right(Freq_27MHZ_Index)) ],'Color', 'k');

plot(real( z2gamma(Z_right(Freq_30MHZ_Index)) ),imag(z2gamma(Z_right(Freq_30MHZ_Index))),'ro','LineWidth',3,'Color', 'm');
text(real( z2gamma(Z_right(Freq_30MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_30MHZ_Index)))+0.1,["30MHz ", num2str(Z_right(Freq_30MHZ_Index)) ],'Color', 'm');

plot(real( z2gamma(Z_right(Freq_50MHZ_Index)) ),imag(z2gamma(Z_right(Freq_50MHZ_Index))),'ro','LineWidth',3,'Color', 'b');
text(real( z2gamma(Z_right(Freq_50MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_50MHZ_Index)))+0.1,["40MHz ", num2str(Z_right(Freq_50MHZ_Index)) ],'Color', 'b');

plot(real( z2gamma(Z_right(Freq_53MHZ_Index)) ),imag(z2gamma(Z_right(Freq_53MHZ_Index))),'ro','LineWidth',3,'Color', 'r');
text(real( z2gamma(Z_right(Freq_53MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_53MHZ_Index)))+0.1,["50MHz ", num2str(Z_right(Freq_53MHZ_Index)) ],'Color', 'r');

plot(real( z2gamma(Z_right(Freq_81MHZ_Index)) ),imag(z2gamma(Z_right(Freq_81MHZ_Index))),'ro','LineWidth',3,'Color', 'g');
text(real( z2gamma(Z_right(Freq_81MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_81MHZ_Index)))+0.1,["60MHz ", num2str(Z_right(Freq_81MHZ_Index)) ],'Color', 'g');

plot(real( z2gamma(Z_right(Freq_188MHZ_Index)) ),imag(z2gamma(Z_right(Freq_188MHZ_Index))),'ro','LineWidth',3,'Color', 'm');
text(real( z2gamma(Z_right(Freq_188MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_188MHZ_Index)))+0.1,["70MHz ", num2str(Z_right(Freq_188MHZ_Index)) ],'Color', 'm');

plot(real( z2gamma(Z_right(Freq_200MHZ_Index)) ),imag(z2gamma(Z_right(Freq_200MHZ_Index))),'ro','LineWidth',3 ,'Color', 'b');
text(real( z2gamma(Z_right(Freq_200MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_200MHZ_Index)))+0.1,[ "80MHZ ", num2str(Z_right(Freq_200MHZ_Index)) ],'Color', 'b');

hold off

end

if Nuclei == "Nuclei_On_Voltage"
hold on

% plot(real( z2gamma(Z_right(Freq_27MHZ_Index)) ),imag(z2gamma(Z_right(Freq_27MHZ_Index))),'ro','LineWidth',3,'Color', 'k');
% text(real( z2gamma(Z_right(Freq_27MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_27MHZ_Index)))+0.1,["27MHZ ", num2str(VI2(Freq_27MHZ_Index)) "Voltz" ],'Color', 'k');
% 
% plot(real( z2gamma(Z_right(Freq_30MHZ_Index)) ),imag(z2gamma(Z_right(Freq_30MHZ_Index))),'ro','LineWidth',3,'Color', 'm');
% text(real( z2gamma(Z_right(Freq_30MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_30MHZ_Index)))+0.1,["3.2MHZ ", num2str(VI2(Freq_30MHZ_Index)) "Voltz" ],'Color', 'm');

plot(real( z2gamma(Z_right(Freq_50MHZ_Index)) ),imag(z2gamma(Z_right(Freq_50MHZ_Index))),'ro','LineWidth',3,'Color', 'b');
text(real( z2gamma(Z_right(Freq_50MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_50MHZ_Index)))+0.1,["13C ", num2str(VI2(Freq_50MHZ_Index)) "dB" ],'Color', 'b');

plot(real( z2gamma(Z_right(Freq_53MHZ_Index)) ),imag(z2gamma(Z_right(Freq_53MHZ_Index))),'ro','LineWidth',3,'Color', 'r');
text(real( z2gamma(Z_right(Freq_53MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_53MHZ_Index)))+0.1,["23Na ", num2str(VI2(Freq_53MHZ_Index))  "dB"],'Color', 'r');

% plot(real( z2gamma(Z_right(Freq_81MHZ_Index)) ),imag(z2gamma(Z_right(Freq_81MHZ_Index))),'ro','LineWidth',3,'Color', 'g');
% text(real( z2gamma(Z_right(Freq_81MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_81MHZ_Index)))+0.1,["81MHZ ", num2str(VI2(Freq_81MHZ_Index)) "Voltz" ],'Color', 'g');
% 
% plot(real( z2gamma(Z_right(Freq_188MHZ_Index)) ),imag(z2gamma(Z_right(Freq_188MHZ_Index))),'ro','LineWidth',3,'Color', 'm');
% text(real( z2gamma(Z_right(Freq_188MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_188MHZ_Index)))+0.1,["188MHZ ", num2str(VI2(Freq_188MHZ_Index)) "Voltz" ],'Color', 'm');

% plot(real( z2gamma(Z_right(Freq_200MHZ_Index)) ),imag(z2gamma(Z_right(Freq_200MHZ_Index))),'ro','LineWidth',3 ,'Color', 'b');
% text(real( z2gamma(Z_right(Freq_200MHZ_Index)) )+0.1,imag(z2gamma(Z_right(Freq_200MHZ_Index)))+0.1,[ "21.2MHZ", num2str(VI2(Freq_200MHZ_Index)) "Voltz" ],'Color', 'b');
hold off

end

end