function [CL,RL,CS,RS] = Stability_Circle(Freq, markersize, Cres, Gammas,S11,S22,S21,S12,Freq_Index) 

Gamma_in = S11(Freq_Index) + ( ( S12(Freq_Index)*S21(Freq_Index)*Gammas) ./ (1 - S22(Freq_Index)*Gammas) ) ;
Gamma_in = abs(Gamma_in);
Gamma_out = S22(Freq_Index) + ( ( S12(Freq_Index)*S21(Freq_Index)*Gammas ) ./ ( 1-S11(Freq_Index)*Gammas ) );
Gamma_out = abs(Gamma_out);


Delta = S11(Freq_Index)*S22(Freq_Index)-S12(Freq_Index)*S21(Freq_Index);
CL = conj( S22(Freq_Index) - Delta * conj(S11(Freq_Index)) ) / ( abs(S22(Freq_Index))^2 - abs(Delta)^2 );
RL = abs(  ( S12(Freq_Index)*S21(Freq_Index) ) / ( abs(S22(Freq_Index))^2 - abs(Delta)^2  )  );

CS = conj( S11(Freq_Index) - Delta * conj(S22(Freq_Index)) ) / ( abs(S11(Freq_Index))^2 - abs(Delta)^2 );
RS = abs(  ( S12(Freq_Index)*S21(Freq_Index) ) / ( abs(S11(Freq_Index))^2 - abs(Delta)^2  )  );

F = num2str( Freq(Freq_Index)*1e-6 );


figure
SmithPlot( Gammas ,Gamma_in,Cres,1,0,"2color",markersize)
title({[F, ' MHz'], 'Stability vs Load Z, yellow-unstable, blue-stable ', ' ' })
figure
SmithPlot( Gammas ,Gamma_out,Cres,1,0,"2color",markersize)
title({[F, ' MHz'], 'Stability vs Source Z, yellow-unstable, blue-stable ', ' ' })

end