function Z = pointsToSurf(x,y,z)
% This function is made to create smooth surfaces from individual scattered
% points

% x, y, z, are the inputs in their respective axes

%% Todo
% 


%% Robustness check
% Send error messages for non-vector quantities
% Send error messages for non equal sizes

nx = size(x); ny = size(y); nz = size(z);

cond_vectors = (min(nx)==1 && min(ny)==1 && min(nz)==1);
cond_sizes = (max(nx)==max(ny) && max(ny)==max(nz) && max(nz)==max(nx));

if ~cond_vectors
    disp('All the inputs should be vectors');
end

if ~cond_sizes
    disp('All the inputs should have same maximum size');
end

    
%% Actual code

% Converting all inputs to uniform column vector
x = x(:); y = y(:); z = z(:);

if cond_vectors && cond_sizes    

    n = 200;        
    %n = Number of points desired, I have put 100 to optimize between speed and accuracy
    
    x_edge=linspace(floor(min(x)),ceil(max(x)),n);
    y_edge=linspace(floor(min(y)),ceil(max(y)),n);

    [X,Y]=meshgrid(x_edge,y_edge);
    Z=griddata(x,y,z,X,Y);
%     surf(X,Y,Z)

end
